package test;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.Source;
import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;


@SuppressWarnings("serial")
@WebServlet("/TestServlet")
public class TestServlet extends HttpServlet 
{   
	
	/** The TransformerFactory used to create Transformer instances */
	protected TransformerFactory transFactory = null;
	   	  
	String xsltTemplatesPath ;
	
	
   /**
    * {@inheritDoc}
    */
   @Override
   public void init() throws ServletException 
   {
	   xsltTemplatesPath = getServletContext().getRealPath("/");
	   
	   System.out.println("ReportsServlet.init() : xsltTemplatesPath==" +xsltTemplatesPath);	   
	   System.out.println("ReportsServlet.init() : getServletContext().getContextPath()==" +getServletContext().getContextPath());
	   System.out.println("ReportsServlet.init() : getServletContext().getServerInfo()==" +getServletContext().getServerInfo());
	   System.out.println("ReportsServlet.init() : getServletContext().getServletContextName()==" +getServletContext().getServletContextName());

	   this.transFactory = TransformerFactory.newInstance();	   
   }   
     
	@Override
	protected void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException 
	{
		// could be many different types of reports, the first one being vfNlConsolidatedReport 
		String reportName = request.getParameter("reportName");
		
			
			// put xmlToTransform.xml files in WEB-INF/classes/
			
				InputStream inputStream = 
						this.getClass().getClassLoader().getResourceAsStream("/xmlToTransform.xml");
				
				
				StringWriter writer = new StringWriter();
				IOUtils.copy(inputStream, writer, "UTF-8");
				String theString = writer.toString();
				
				createExcelDocumentViaXslt(request,response, theString);

	}
		
	private void createExcelDocumentViaXslt(HttpServletRequest request,
											HttpServletResponse response, 
											String xmlToTransform) 
	{
		DateFormat dateFormat = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
		
			PrintWriter out;
			//OutputStream out;
			try {				
				response.setHeader("Content-Type","application/vnd.ms-excel; charset=UTF-8");
				response.setCharacterEncoding("UTF-8");
				response.setHeader("Content-Disposition", "attachment; filename=\"xmlToTransform.xls\"");
				response.setHeader("Pragma", "no-cache");

				out = response.getWriter();
				
				// put xmlToTransform.xslt files in WEB-INF/classes/
				InputStream inputStream = 
						this.getClass().getClassLoader().getResourceAsStream("/xmlToTransform.xslt");
				
				InputStreamReader isr = new InputStreamReader(inputStream, "UTF-8");

				Source xsltStreamSource = new StreamSource(isr);
				
				// 1st convert a String to a Source 
				StreamSource xmlStreamSource = new StreamSource(new ByteArrayInputStream(xmlToTransform.getBytes("UTF-8")));

				Templates xsltTemplate = transFactory.newTemplates(xsltStreamSource);
				Transformer transformer = xsltTemplate.newTransformer();
				
				// add some parameters to be used in the final PDF output
				java.util.Calendar calendar = new GregorianCalendar();
				transformer.setParameter("created",dateFormat.format(Calendar.getInstance().getTime()));
				int rowCount = StringUtils.countMatches(xmlToTransform, "<ROW>");
								
				transformer.setParameter("rowCount", rowCount);
				transformer.setParameter("columnCount", 11);
								
				transformer.transform(xmlStreamSource, new StreamResult(out));
				
			} catch (Exception e1) {
				e1.printStackTrace();
			}

	}

}
